package com.picfun.bt_mp3cont;

import com.picfun.bt_mp3cont.BT_MP3Cont;
import com.picfun.bt_mp3cont.BluetoothClient;
import com.picfun.bt_mp3cont.DeviceListActivity;

import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.annotation.SuppressLint;
import android.app.Activity;
import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothDevice;
import android.content.Intent;
import android.graphics.Color;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.TextView;
import android.widget.Toast;
import java.io.UnsupportedEncodingException;

@SuppressLint("HandlerLeak")

public class BT_MP3Cont extends Activity {
	/**** クラス定数宣言定義 ****/
	public static final int CONNECTDEVICE = 1;
	public static final int ENABLEBLUETOOTH = 2;
	// Bluetoothインスタンス定数
	private BluetoothAdapter BTadapter;
	private BluetoothClient BTclient;
	// クラス定数の宣言定義
	private static Button connect, volumeup, volumedown, bassup, bassdown;
	private static Button trebup, trebdown, select;
	private static TextView music, band, album;
	private static TextView text1, text3;
	private byte[] RcvPacket = new byte[512];			// 受信バッファ
	private byte[] SndPacket = new byte[3];			// 送信バッファ
	
	/******************** 最初に実行するメソッド ************************/
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        // **** GUI画面表示 ****/       
        setContentView(R.layout.mp3_cont);
        //コンポーネントの名称設定
        connect 	= (Button)this.findViewById(R.id.connect);
        volumeup	= (Button)this.findViewById(R.id.volumeup);
        volumedown 	= (Button)this.findViewById(R.id.volumedown);
        bassup 		= (Button)this.findViewById(R.id.bassup); 
        bassdown 	= (Button)this.findViewById(R.id.bassdown);
        trebup 		= (Button)this.findViewById(R.id.trebup);
        trebdown 	= (Button)this.findViewById(R.id.trebdown);
        select 		= (Button)this.findViewById(R.id.select);         
        music    	= (TextView)this.findViewById(R.id.musictitle);        
        band   		= (TextView)this.findViewById(R.id.band);
        album   	= (TextView)this.findViewById(R.id.album);             
        text1    	= (TextView)this.findViewById(R.id.text1);        
        text3    	= (TextView)this.findViewById(R.id.text3);     
        // ボタンイベント組み込み
        connect.setOnClickListener((OnClickListener) new SelectExe()); 
        volumeup.setOnClickListener((OnClickListener) new VolumeUp_Control());
        volumedown.setOnClickListener((OnClickListener) new VolumeDown_Control()); 
        bassup.setOnClickListener((OnClickListener) new BassUp_Control());
        bassdown.setOnClickListener((OnClickListener) new BassDown_Control());
        trebup.setOnClickListener((OnClickListener) new TrebUp_Control());
        trebdown.setOnClickListener((OnClickListener) new TrebDown_Control());
        select.setOnClickListener((OnClickListener) new GoAhead());
        
		// Bluetoothが有効な端末か確認
		BTadapter = BluetoothAdapter.getDefaultAdapter();
		if (BTadapter == null) {
			text3.setTextColor(Color.YELLOW);
			text3.setText("Bluetooth非サポート");
		}
    }
	/************* アクティビティ開始時（ストップからの復帰時） *********/
	@Override
	public void onStart() {
		super.onStart();
		if (BTadapter.isEnabled() == false) {		// Bluetoorhが有効でない場合
			// Bluetoothを有効にするダイアログ画面に遷移し有効化要求
			Intent BTenable = new Intent(BluetoothAdapter.ACTION_REQUEST_ENABLE);
			// 有効化されて戻ったらENABLEパラメータ発行
			startActivityForResult(BTenable, ENABLEBLUETOOTH);
		}
		else {
			if (BTclient == null) {
				// BluetoothClientをハンドラで生成
				BTclient = new BluetoothClient(this, handler);
			}
		}
	}
	/********* アクティビティ再開時（ポーズからの復帰時） ***************/
	@Override
	public synchronized void onResume() {
		super.onResume();
		// 特に処理なし
	}
	/****** アクティビティ破棄時 **********/
	@Override
	public void onDestroy() {
		super.onDestroy();
		if (BTclient != null) {
			BTclient.stop();
		}
	}
    /********* 接続ボタンイベントクラス ******************/
    class SelectExe implements OnClickListener{
    	public void onClick(View v){
 			// デバイス検索と選択ダイアログへ移行    		
    		Intent Intent = new Intent(BT_MP3Cont.this, DeviceListActivity.class);
 			// 端末が選択されて戻ったら接続要求するようにする
 			startActivityForResult(Intent, CONNECTDEVICE);   	    		
    	}
    }	
	/******* 遷移ダイアログからの戻り処理 ****************/
	public void onActivityResult(int requestCode, int resultCode, Intent data) {
		switch (requestCode) {
			// 端末選択ダイアログからの戻り処理
			case CONNECTDEVICE: 			// 端末が選択された場合
				if (resultCode == Activity.RESULT_OK) {
					String address = data.getExtras().getString(DeviceListActivity.DEVICEADDRESS);
					// 生成した端末に接続要求
					BluetoothDevice device = BTadapter.getRemoteDevice(address);
					BTclient.connect(device);		// 端末へ接続
				}
				break;
			// 有効化ダイアログからの戻り処理
			case ENABLEBLUETOOTH: 			// Bluetooth有効化
				if (resultCode == Activity.RESULT_OK) {
					// 正常に有効化できたらクライアントをハンドラで生成
					BTclient = new BluetoothClient(this, handler);
				}
				else {
					Toast.makeText(this, "Bluetoothのサポートなし", Toast.LENGTH_SHORT).show();
					finish();
				}
		}
	}
 	/******* 音量アップボタンイベント処理サブクラス ******/
    class VolumeUp_Control implements OnClickListener{
    	public void onClick(View v){
      		SndPacket[0] = 0x53;				// S
			SndPacket[1] = 0x55;				// U
			SndPacket[2] = 0x45;				// E
			BTclient.write(SndPacket); 			// 送信実行	
    	}
    }
 	/******* 音量ダウンボタンイベント処理サブクラス ******/
    class VolumeDown_Control implements OnClickListener{
    	public void onClick(View v){
      		SndPacket[0] = 0x53;				// S
			SndPacket[1] = 0x4C;				// L
			SndPacket[2] = 0x45;				// E
			BTclient.write(SndPacket); 			// 送信実行	
    	}
    }
 	/******* 低音アップボタンイベント処理サブクラス ******/
    class BassUp_Control implements OnClickListener{
    	public void onClick(View v){
      		SndPacket[0] = 0x53;				// S
			SndPacket[1] = 0x42;				// B
			SndPacket[2] = 0x45;				// E
			BTclient.write(SndPacket); 			// 送信実行	
    	}
    }
 	/******* 低音ダウンボタンイベント処理サブクラス ******/
    class BassDown_Control implements OnClickListener{
    	public void onClick(View v){
      		SndPacket[0] = 0x53;				// S
			SndPacket[1] = 0x43;				// C
			SndPacket[2] = 0x45;				// E
			BTclient.write(SndPacket); 			// 送信実行	
    	}
    } 
 	/******* 高音アップボタンイベント処理サブクラス ******/
    class TrebUp_Control implements OnClickListener{
    	public void onClick(View v){
      		SndPacket[0] = 0x53;				// S
			SndPacket[1] = 0x48;				// H
			SndPacket[2] = 0x45;				// E
			BTclient.write(SndPacket); 			// 送信実行	
    	}
    }
 	/******* 高音ダウンボタンイベント処理サブクラス ******/
    class TrebDown_Control implements OnClickListener{
    	public void onClick(View v){
      		SndPacket[0] = 0x53;				// S
			SndPacket[1] = 0x49;				// I
			SndPacket[2] = 0x45;				// E
			BTclient.write(SndPacket); 			// 送信実行	
    	}
    }   
 	/******* 次の曲選択ボタンイベント処理サブクラス ******/
    class GoAhead implements OnClickListener{
    	public void onClick(View v){
      		SndPacket[0] = 0x53;				// S
			SndPacket[1] = 0x4E;				// N
			SndPacket[2] = 0x45;				// E
			BTclient.write(SndPacket); 			// 送信実行	
    	}
    }    
	/******* BT端末接続処理のハンドラで戻り値ごとの処理 **/
	private final Handler handler = new Handler() {

		// ハンドルメッセージごとの処理
		@Override
		public void handleMessage(Message msg) {
			switch (msg.what) {
				case BluetoothClient.MESSAGE_STATECHANGE:
					switch (msg.arg1) {
						case BluetoothClient.STATE_CONNECTED:
							text1.setTextColor(Color.GREEN);
							text1.setText("接続完了");
							break;
						case BluetoothClient.STATE_CONNECTING:
							text1.setTextColor(Color.WHITE);
							text1.setText("接続中");
							break;
						case BluetoothClient.STATE_NONE:
							text1.setTextColor(Color.RED);
							text1.setText("接続失敗");
							break;
					}
					break;
				// BT受信処理
				case BluetoothClient.MESSAGE_READ:
					RcvPacket = (byte[])msg.obj;
					Process();
					break;
			}
		}
	}; 
	/************** 受信データ処理メソッド ***************/
	public void Process(){
		byte[] data1 = new byte[256];
		byte[] data2 = new byte[256];
		byte[] data3 = new byte[256];
		int ptr, i;
		
		if(RcvPacket[2] != 0x0D){
			ptr = 2;								// MAを飛ばす
			i = 0;
			while(RcvPacket[ptr] != 0x0A){			// 曲名取り出し
				data1[i++] = RcvPacket[ptr++];		// 曲名コピー
			}
			data1[i++] = 0;							// 配列終了
			ptr++;									// 次へ
			i = 0;
			while(RcvPacket[ptr] != 0x0A){			// バンド名取り出し
				data2[i++] = RcvPacket[ptr++];		// バンド名コピー
			}
			data2[i++] = 0;							// 配列終了
			ptr++;									// 次へ
			i = 0;
			while(RcvPacket[ptr] != 0x0A){			// アルバム名取り出し
				data3[i++] = RcvPacket[ptr++];		// アルバム名コピー
			}
			data3[i++] = 0;							// 配列終了
			
			try{
				music.setTextColor(Color.WHITE);
				String Message1 = new String(data1, "Shift_JIS");	// 変換
				music.setText(Message1);							// 表示出力
				String Message2 = new String(data2, "Shift_JIS");	// 変換
				band.setText(Message2);								// 表示出力
				String Message3 = new String(data3, "Shift_JIS");	// 変換
				album.setText(Message3);							// 表示出力
			}catch(UnsupportedEncodingException e){
				
			}
		}
		else{
			music.setTextColor(Color.YELLOW);
			music.setText("曲の情報が未登録です！！");
		}
	}
}
