package com.picfun.wifipio;

import com.picfun.wifipio.R;
import android.os.Bundle;
import android.app.Activity;
import android.graphics.Color;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;
import java.net.Socket;
import java.io.IOException;
import java.io.DataOutputStream;
import java.io.DataInputStream;
import android.os.Handler;
import java.util.Timer;
import java.util.TimerTask;
import android.view.WindowManager;

public class WiFiPIO extends Activity {
	// GUI関連クラス定数、変数の定義
	private Button Connect, Cont1, Cont2;
	private EditText Host;
	private TextView State, State1, State2, Mesr1, Mesr2;
	static Timer timer;
	static int ContFlag1 = 0;
	static int ContFlag2 = 0;
	private static int Data1, Data2;
	// ソケット関連変数定義
	Handler handler= new Handler();	
	static Socket socket = null;
	static DataOutputStream out;
	static DataInputStream in;	
	private byte[] Buffer = new byte[64];
	
	/**** 最初に実行するメソッド ***********************/
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);	
		// キーボードを隠す
		getWindow().setSoftInputMode(
				WindowManager.LayoutParams.SOFT_INPUT_STATE_HIDDEN);
		// 画面の表示
		setContentView(R.layout.main);
        //コンポーネントの設定
        Connect = (Button)this.findViewById(R.id.button1);
        Cont1 = (Button)this.findViewById(R.id.button2);
        Cont2 = (Button)this.findViewById(R.id.button3);
        Host = (EditText)this.findViewById(R.id.editText1);
        State = (TextView)this.findViewById(R.id.textView1);
        State1 = (TextView)this.findViewById(R.id.textView2);
        State2 = (TextView)this.findViewById(R.id.textView3);       
        Mesr1 = (TextView)this.findViewById(R.id.textView4);
        Mesr2 = (TextView)this.findViewById(R.id.textView5);          
        // ボタンイベント組み込み
        Connect.setOnClickListener((OnClickListener) new connect());		
        Cont1.setOnClickListener((OnClickListener) new control1());
        Cont2.setOnClickListener((OnClickListener)new control2());
	}
    /**** アプリ遷移イベント関連メソッド ***************/
	@Override
	public void onStart() {
		super.onStart();
	}
	@Override
	protected void onStop(){
		super.onStop();
		try{
			if(socket != null){	
				out.writeBytes("SNE");		// 終了コマンド送信
				socket.close();
				socket = null;
			}
		}catch (IOException e){
		}
	}
	
    /**** 接続ボタンイベント処理サブクラス *************/
    class connect implements OnClickListener{
    	public void onClick(View v){
    		/**** 接続処理のスレッドを生成し起動  ***/
    		Thread clientThread = new Thread(new ClientThread());
    		clientThread.start();	    		
    	}
    }
    /**** 制御１ボタンイベント処理サブクラス ***********/
    class control1 implements OnClickListener{
    	public void onClick(View v){
    		if(Cont1.getText() == "Off")
    			ContFlag1 = 1;
    		else
    			ContFlag1 = 2;
    	}
    }
    /**** 制御2ボタンイベント処理サブクラス ************/
    class control2 implements OnClickListener{
    	public void onClick(View v){
    		if(Cont2.getText() == "Off")
    			ContFlag2 = 1;
    		else
    			ContFlag2 = 2;
    	}  
    }    
    /**** 端末接続実行スレッド *************************/
    public class ClientThread implements Runnable{
    	public void run(){
    		
    		handler.post(new Runnable(){
    			public void run(){
    				State.setText("接続開始");
    			}
    		});
    		/***　IPアドレスとポート番号を取得 **/
    		String address = Host.getText().toString();
    		int port = 2000; 		
    		/** 接続実行 **/
   			try{
   				socket = new Socket(address, port); 	
   				handler.post(new Runnable(){
   					public void run(){
						State.setTextColor(Color.BLACK);  						
   						State.setText("接続完了");
   					}
   				});
   				/*** ストリームを取得 ***/
   		    	out = new DataOutputStream(socket.getOutputStream());
   		    	in = new DataInputStream(socket.getInputStream()); 		    	
   		    	/**** タイマ起動と周期起動タスクのスタート ****/
   		    	timer = new Timer(true);
   		    	timer.schedule(new TimerTask(){
	    			@Override
	    			public void run(){
	    				/**** 周期起動のスレッドを生成し起動 ***/
	    				Thread periodThread = new Thread(new periodThread());
	    				periodThread.start();
	    			}
   				}, 1000, 500);						// 最初1秒待ち、以後1秒周期 
    		}catch (IOException e){
        		handler.post(new Runnable(){
        			public void run(){
						State.setTextColor(Color.RED);       				
        				State.setText("接続失敗");
        			}
        		});   			
    		}
    	}
    } 
    /**** 周期的に状態要求を送信するスレッド ***********/
    public class periodThread implements Runnable{
   		public void run(){
   			int count = 0;
   			
   			try{
   				/** 受信データ有無のチェック　***/
   				count = in.available();				// 受信データ個数取得
   				/*** 受信データの処理 ***/	
   				if(count >= 32){					// 受信データありの場合
   					in.read(Buffer);				// 受信データをBufferに取り出し
   					/**** 受信データ処理 ****/
   					if((Buffer[0] == 0x4D)&&(Buffer[1] == 0x42))
   					{
   						/*** 状態データ処理 ****/
   						handler.post(
   							new Runnable()
	   						{
	   							public void run()
	   							{   								
	   								if(Buffer[2] == 0x31){
	   									Cont1.setBackgroundColor(Color.RED);
	   									Cont1.setText("On");
	   								}
	   								else{
	   									Cont1.setBackgroundColor(Color.GREEN);
	   									Cont1.setText("Off");
	   								}
	   								if(Buffer[3] == 0x31){
	   									Cont2.setBackgroundColor(Color.RED);
	   									Cont2.setText("On");
	   								}
	   								else{
	   									Cont2.setBackgroundColor(Color.GREEN);
	   									Cont2.setText("Off");
	   								}
	   								/*** 状態データ処理****/
	   								if(Buffer[4] == 0x30){
	   									State1.setBackgroundColor(Color.RED);
	   									State1.setText("On");
	   								}
	   								else{
	   									State1.setBackgroundColor(Color.GREEN);
	   									State1.setText("Off");
	   								}
	   								if(Buffer[5] == 0x30){
	   									State2.setBackgroundColor(Color.RED);
	   									State2.setText("On");
	   								}
	   								else{
	   									State2.setBackgroundColor(Color.GREEN);
	   									State2.setText("Off");
	   								}
			   						/*** 計測データ処理 ***/
			   						Data1 = (Buffer[6]-0x40)*32+Buffer[7]-0x40;
	   								Mesr1.setText(Integer.toString(Data1));
			   						Data2 = (Buffer[8]-0x40)*32+Buffer[9]-0x40;	   								
	   								Mesr2.setText(Integer.toString(Data2));	   								
	   							}
	   						}
   						);
   					}
	   			}
   				/***** 受信データがない場合制御実行 *****/
	   			else{
   					/*** 制御が無い場合状態要求送信 ***/	   				
	   				if((ContFlag1 == 0)&&(ContFlag2 == 0))
   						out.writeBytes("SBE");   						
	   				/*** 制御実行 ****/
   					if(ContFlag1 == 1)			
   						out.writeBytes("SC11E");
   					else if(ContFlag1 == 2)
   						out.writeBytes("SC10E");
   					ContFlag1 = 0;
   					if(ContFlag2 == 1)
   						out.writeBytes("SC21E");
   					else if(ContFlag2 == 2)
   						out.writeBytes("SC20E");
   					ContFlag2 = 0;
	   			}
   				
    		}catch(IOException e){
        		handler.post(new Runnable(){
        			public void run(){
						State.setTextColor(Color.RED);       				
        				State.setText("送受信失敗");
        			}
        		});
    		}
   		}
	}
}

