/**********************************************
* PIC24FJ64GA002 family
*  BT_MP3: VS1011E$B1~MQ!!(BMP3$B:F@8%W%m%0%i%`(B
*  $B%^%$%/%m%A%C%W$N(BMDD$B%U%!%$%k%7%9%F%`$r;HMQ(B
*  SD$B%+!<%IFb$N(BMP3$B$N%U%!%$%k$O%k!<%H$K$N$_J]B8(B
*  $B%G%#%l%/%H%j$O07$C$F$$$J$$$N$GL5;k$5$l$k(B
*  SD:SPI1    MP3:SPI2
*  Bluetooth$B$G%j%b%3%s!"A`:n$H6JL>Ey$NI=<((B
***********************************************/
#include <xc.h>
#include "GenericTypeDefs.h"
#include "FSIO.h"
#include "VS1011.h"
/* $B%3%s%U%#%.%e%l!<%7%g%s$N@_Dj(B */
_CONFIG1( JTAGEN_OFF & GCP_OFF & GWRP_OFF & BKBUG_OFF
	 & COE_OFF & ICS_PGx1& FWDTEN_OFF )
/* 8MHz*PLL4=32MHz (Full Speed)  */
_CONFIG2( IESO_OFF & FNOSC_FRCPLL & FCKSM_CSDCMD
	 & OSCIOFNC_ON & IOL1WAY_OFF & I2C1SEL_PRI & POSCMOD_NONE)

/* MDD$B%U%!%$%kMQ9=B$BN$N%]%$%s%?JQ?t(B  */
FSFILE  *fptr;
size_t  result;
SearchRec Record;
SearchRec *rptr = &Record;
__attribute__((far)) unsigned char Buffer[512];
/* MP3$BMQJQ?t(B  */
BYTE Volume, ChgFlag, BASS, TREB;
__attribute__((far)) unsigned char Header[1024];
unsigned int Index, locate, NameSize;
/* BT$BMQ%P%C%U%!(B */
#define  Max_Size  512
__attribute__((far)) unsigned char RcvBuf[64];
__attribute__((far)) unsigned char SndBuf[Max_Size];
/* Blutooth$B@_DjMQ%3%^%s%I%G!<%?(B */
const unsigned char msg1[] = "$$$";                 // $B%3%^%s%I%b!<%I;XDj(B
const unsigned char msg2[] = "SF,1\r";              // $B=i4|2=(B
const unsigned char msg3[] = "SN,BT_MP3\r";        // AP$B$N(BSSID$B;XDj(B
const unsigned char msg4[] = "R,1\r";               // $B:F5/F0(B
/* $B4X?t%W%m%H%?%$%T%s%0(B  */
void SendUART(unsigned char Data);
void SendBT(unsigned char * ptr, int size);
void SendCmd(const unsigned char *cmd);
void SendStr(unsigned char *ptr);
void Transfer(void);

/********* $B%a%$%s4X?t(B ***************************/
int main(void){
    int i;
    
    CLKDIVbits.RCDIV  = 0;			// $B%/%m%C%/(B1/1
    /* $BF~=PNO%]!<%H@_Dj(B  */
    AD1PCFG = 0xFFFF;				// $B$9$Y$F%G%8%?%k(B
    TRISA = 0xFFFC;				//
    TRISB = 0x878F;				//
    /* $B%9%$%C%A>uBVJQ2=3d$j9~$_$N5v2D(B  */
    CNPU1 = 0x0001;				// CN0(RA4)
    CNEN1 = 0x0001;
    CNPU2 = 0x6060;                             // CN29(RA3) CN30(RA2) CN21(RB9), CN22(RB8)
    CNEN2 = 0x6000;
    IPC4bits.CNIP = 5;                          // $B3d$j9~$_%l%Y%k;XDj(B
    IEC1bits.CNIE = 1;                          // $B3d$j9~$_5v2D(B
    /* UART1$B%T%s3dIU(B */
    RPINR18bits.U1RXR = 2;                      // UART1 RX to RP2
    RPOR1bits.RP3R = 3;                         // UART1 TX to RP3
    /* UART1$B=i4|@_Dj!!(B115kbps  */
    U1MODE = 0x8808;                            // UART1$B=i4|@_Dj(B BRGH=1
    U1STA =  0x0400;                            // UART1$B=i4|@_Dj(B
    U1BRG = 34;                                 // 115kbps@32MHz
    IPC2bits.U1RXIP = 4;                        // UART1$B3d$j9~$_%l%Y%k(B
    IFS0bits.U1RXIF = 0;                        // $B3d$j9~$_%U%i%0%/%j%"(B
    IEC0bits.U1RXIE = 1;                        // UART1$B<u?.3d$j9~$_5v2D(B
    /* SPI$B$N%T%s3d$jIU$1(B  */
    RPINR20bits.SDI1R = 7;			// SDI1$B$r(BRP7$B$K(B
    RPOR3bits.RP6R = 8;                         // SCK1$B$r(BRP6$B$K(B
    RPOR2bits.RP5R = 7;                         // SDO1$B$r(BRP5$B$K(B
    RPINR22bits.SDI2R = 10;			// SDI2$B$r(BRP10$B$K(B
    RPOR6bits.RP12R = 11;			// SCK2$B$r(BRP12$B$K(B
    RPOR5bits.RP11R = 10;			// SDO2$B$r(BRP11$B$K(B
    /*** Bluetooth$B%b%8%e!<%k$N=i4|2=(B ****/
    LATAbits.LATA1 = 0;                         // BT Reset
    delay_ms(200);                              // $B%Q%k%9I}3NJ](B
    LATAbits.LATA1 = 1;                         // $B%j%;%C%H2r=|(B
    if(PORTAbits.RA4 == 0)                      // S2$B$,2!$5$l$F$$$?>l9g$N$_<B9T(B
    {
        /** Bluetooth$B%b%8%e!<%k=i4|2=(B */
        delay_ms(1000);                         // $B=i4|2=<B9TBT$A(B
        SendCmd(msg1);                          // $$$
        SendCmd(msg2);                          // $B9)>l=P2Y;~%j%;%C%H(B
        SendCmd(msg3);                          // $BL>>NIUM?(B
        SendCmd(msg4);                          // $B%j%V!<%H(B
        delay_ms(2000);                         // $B%a%C%;!<%8%9%-%C%W(B
    }
    /* $BJQ?t=i4|2=(B */
    Index = 0;
    ChgFlag = 0;
    /*$B!!(BVS1011e$B$N=i4|2=!!(B*/
    VS1011_Init();                              // $B=i4|2=<B9T(B
    Volume = 0x30;                              // $B2;NL$N=i4|@_Dj(B
    SetVolume(Volume, Volume);                  // $B@)8f<B9T(B
    BASS = 0;					// $BDc2;%U%i%C%H(B
    TREB = 0;                                   // $B9b2;%U%i%C%H(B
    SetBoost(BASS, 15, TREB, 5);                // $B@)8f<B9T(B
    ChgFlag = 1;                                // $B:G=i@)8f<B9T(B
    /* VS1011$B$N%G%P%C%0;~%F%9%HMQ$N%3%^%s%I!!!!(B*/
//    	VS1011_SineTest();			// $B@589GH=PNO%F%9%H(B
//        while(1);
    /* $B%+!<%I$N<BAu3NG'$H%G%#%l%/%H%jFI$_9~$_(B $B!J1J5WBT$A!K(B */
    while(!FSInit());				// FAT$B$N=i4|2=(B
    /* $B:G=i$N%U%!%$%k$N%5!<%A!J%k!<%H$@$1$K(BMP3$B%U%!%$%k$,$"$k$3$H$,A0Ds!K(B  */
    result = FindFirst("*.*", ATTR_ARCHIVE, rptr);
    if(result == 0){
        fptr = FSfopen(Record.filename, FS_READ);   // $B%U%!%$%k$N%*!<%W%s(B
    }

    /**************** $B%a%$%s%k!<%W!!(B********************************************/
    while(1){
        /* $B2;3Z%G!<%?$N=PNO(B */
        if(fptr != 0){						// $B@5>o$K%*!<%W%s$G$-$?$+!)(B
            /* $B%U%!%$%k$N(BEOF$B$^$G2;@<%G!<%?O"B3=PNO(B */
            do{
                /***** $B99?7%U%i%0%A%'%C%/$H@)8f(B *****/
                if(ChgFlag){					// $B99?7$"$j$+!)(B
                    ChgFlag = 0;                                // $B%U%i%0%/%j%"(B
                    SetVolume(Volume, Volume);                  // $B2;NL@_Dj(B
                    SetBoost(BASS, 15, TREB, 5);		// $B2;<A@_Dj(B
                }
                /****** $B2;3Z%G!<%?$N:F@8!!(B******/
                SRbits.IPL = 7;					// SPI$B=hM}Cf$O3d$j9~$_6X;_(B
                MP3_XDCS_IO = 0;                                // $B%G!<%?MQ(BCS$B%;%C%H(B
                /* 512$B%P%$%HC10L$G%U%!%$%k%j!<%I!!(B*/
                result = FSfread(Buffer, 1, 512, fptr);         // 512$B%P%$%HFI$_=P$7(B
                for(i= 0; i<result; i++){			// $BFI$_=P$7$?%P%$%H?t$@$17+$jJV$7(B
                    SendData(Buffer[i]);			// $B2;3Z%G!<%?Aw?.(B
                }
                SRbits.IPL = 2;					// $B3d$j9~$_:F5v2D(B
            } while(result != 0);				// $B%U%!%$%k$N(BEOF$B$^$G7QB3(B
            /******* $B:F@840N;=hM}(B ********/
            MP3_XDCS_IO = 1;                                    // $B%A%C%WA*Br2r=|(B
            FSfclose(fptr);					// $B%U%!%$%k$N%/%m!<%:(B
            PlayEnd();						// $B:F@8=*N;=hM}(B
            /* $BO"B3:F@8$N$?$a<!$N%U%!%$%k%5!<%A(B */
            result = FindNext(rptr);				// $B<!$N%U%!%$%k$X(B
            if((result==0)&&(Record.attributes==ATTR_ARCHIVE)){ // $B%U%!%$%k$,$"$C$?>l9g(B
                fptr = FSfopen(Record.filename, FS_READ);       // $B%U%!%$%k$r%*!<%W%s(B
                Transfer();                                     // $B6J%G!<%?Aw?.(B
            }
            else   /* $B%U%!%$%k$N=*$o$j$J$i:FEY:G=i$+$i7+$jJV$7(B  */
            {
                result = FindFirst("*.*", ATTR_ARCHIVE, rptr);  // $B:G=i$N%U%!%$%k$rC5$9(B
                if(result == 0){                                // $B8+$D$+$C$?>l9g(B
                    fptr = FSfopen(Record.filename, FS_READ);	// $B%U%!%$%k$N%*!<%W%s(B
                    Transfer();                                 // $B6J%G!<%?Aw?.(B
                }
            }
            SRbits.IPL = 2;					// $B3d$j9~$_:F5v2D(B
        }
    }
}
/********************************************
 * $BA*Br$7$?6J%G!<%?$N%X%C%@$rAw?.$9$k(B
 *$B!!6JL>$H%P%s%IL>(B
 *******************************************/
void Transfer(void){
    int i, ptr;

    ptr = 0;                                            // $B%P%C%U%!%]%$%s%?%j%;%C%H(B
    result = FSfread(Header, 1, 1024, fptr);            // $B%U%!%$%k$N%X%C%@It(B1KB$BFI$_9~$_(B
    /******* $B6JL>%5!<%A(B (TIT2) ***********/
    locate = 0;                                         // $B%P%C%U%!%$%s%G%C%/%9%j%;%C%H(B
    for(i=0; i<768; i++){                               // $B%P%C%U%!$NA0H>$NHO0O$G%5!<%A(B
        if((Header[i] == 'T') && (Header[i+1]== 'I')    // TIT2$BC5:w(B
            && (Header[i+2] == 'T') && (Header[i+3] == '2')){
            locate = i;                                 // TIT2$BH/8+$G%U%i%0%*%s(B
            break;                                      // $B%5!<%A6/@)=*N;$7<!$X(B
        }
    }
    /* $B6JL>%X%C%@$"$j$N>l9g6JL>Aw?.!!(B*/
    if(locate != 0){                                    // $BH/8+$7$?>l9g(B
        NameSize = Header[locate+7]-1;                  // $B6JL>%G!<%?$ND9$5(B(Max256B$B$NA0Ds(B)
        Header[locate + NameSize + 11] = 0x0D;          // $BG[Ns=*N;%^!<%/%;%C%H(B
        Header[locate + NameSize + 12] = 0x0A;          // $B$3$3$^$G$,6JL>(B
        SndBuf[ptr++] = 'M';                            // $B%X%C%@=q$-9~$_(B
        SndBuf[ptr++] = 'A';
        for(i=0; i<NameSize+2; i++)                     // $B6JL>D9$5J,7+$jJV$7(B
            SndBuf[ptr++] = Header[locate+11+i];        // $B6JL>%G!<%?%3%T!<(B
    }
    else{                                               // $B6JL>H/8+$G$-$J$+$C$?>l9g(B
        SndBuf[ptr++] = 0x0D;                           // $B6JL>$J$7$N>l9g(BCR$B$N$_(B
        SndBuf[ptr++] = 0x0A;
    }
    /******* $B%P%s%IL>%5!<%A(B (TPE1) ********/
    locate = 0;                                         // $B%P%C%U%!%]%$%s%?%j%;%C%H(B
    for(i=0; i<result; i++){                            // $B:G8e$^$G%5!<%A(B
        if((Header[i] == 'T') && (Header[i+1]== 'P') && (Header[i+2] == 'E')
                && (Header[i+3] == '1')){               // TPE1$B$GC5:w(B
            locate = i;                                 // TPE1$BH/8+$G%U%i%0%*%s(B
            break;                                      // $B%5!<%A6/@)=*N;$7<!$X(B
        }
    }
    /* $B%P%s%IL>$"$j$N>l9g%P%s%IL>Aw?.!!(B*/
    if(locate != 0){                                    // $BH/8+$7$?>l9g(B
        NameSize = Header[locate+7]-1;                  // $B%P%s%IL>%G!<%?D9(B
        Header[locate + NameSize + 11] = 0x0D;          // $BG[Ns=*N;%^!<%/%;%C%H(B
        Header[locate + NameSize + 12] = 0x0A;
        for(i=0; i<NameSize+2; i++)
            SndBuf[ptr++] = Header[locate+11+i];        // $B%P%s%IL>%;%C%H(B
    }
    else{                                               // $BH/8+$G$-$J$+$C$?>l9g(B
        SndBuf[ptr++] = 0x0D;                           // $B%P%s%IL>$J$7$N>l9g(BCR$B$N$_(B
        SndBuf[ptr++] = 0x0A;
    }
    /******* $B%"%k%P%`L>%5!<%A(B (TALB) ********/
    locate = 0;                                         // $B%P%C%U%!%]%$%s%?%j%;%C%H(B
    for(i=0; i<result; i++){                            // $B:G8e$^$G%5!<%A(B
        if((Header[i] == 'T') && (Header[i+1]== 'A') && (Header[i+2] == 'L')
                && (Header[i+3] == 'B')){               // TALB$B$GC5:w(B
            locate = i;                                 // TALB$BH/8+$G%U%i%0%*%s(B
            break;                                      // $B%5!<%A6/@)=*N;$7<!$X(B
        }
    }
    /* $B%"%k%P%`L>$"$j$N>l9g%"%k%P%`L>Aw?.(B */
    if(locate != 0){                                    // $BH/8+$7$?>l9g(B
        NameSize = Header[locate+7]-1;                  // $B%"%k%P%`L>%G!<%?D9(B
        Header[locate + NameSize + 11] = 0x0D;          // $BG[Ns=*N;%^!<%/%;%C%H(B
        Header[locate + NameSize + 12] = 0x0A;
        Header[locate + NameSize + 13] = 0xFF;          // $B%G!<%?=*N;%^!<%/%;%C%H(B
        for(i=0; i<NameSize+3; i++)                     // $B%"%k%P%`L>D9$5$@$17+$jJV$7(B
            SndBuf[ptr++] = Header[locate+11+i];        // $B%"%k%P%`L>%;%C%H(B
    }
     else{                                              // $BH/8+$G$-$J$+$C$?>l9g(B
        SndBuf[ptr++] = 0x0D;                           // $B%"%k%P%`L>$J$7$N$H$-(BCR$B$N$_(B
        SndBuf[ptr++] = 0x0A;
        SndBuf[ptr++] = 0xFF;                           // $B%G!<%?$N=*N;%^!<%/(B
        SndBuf[ptr++] = 0xFF;
    }
    // $B6J>pJs0l3gAw?.(B
    SendBT(SndBuf, 512);                                // $BAw?.<B9T(B512$B%P%$%H0lDjD9(B
}
/******************************************
* $B%9%$%C%A>uBVJQ2=3d$j9~$_=hM}(B
*******************************************/
void __attribute__((interrupt, no_auto_psv)) _CNInterrupt(void){
    /* $B%9%$%C%A$N%A%'%C%/(B  */
    if(PORTAbits.RA2 == 0){                                 // SW1$B2;NL%"%C%W(B
        if(Volume > 4)                                      // $B:G9b(B0(0dB)
            Volume -= 4;                                    // 2dB$B$:$D>e$2$k(B
        ChgFlag = 1;                                        // $BJQ99%U%i%0%*%s(B
    }
    if(PORTAbits.RA3 == 0){                                 // SW2$B2;NL%@%&%s(B
        if(Volume < 0xC0)                                   // $B:GDc$r(B0xC0$B$G@)8B!JL52;!K(B
            Volume += 4;                                    // 2dB$B$:$D2<$2$k(B
        ChgFlag = 1;                                        // $BJQ99%U%i%0%*%s(B
    }
    if(PORTAbits.RA4 == 0){                                 // SW3$B!!<!$N%U%!%$%k$X(B
        FSfclose(fptr);                                     // $B8=:_$N%U%!%$%k$r6/@)%/%m!<%:(B
        PlayEnd();                                          // $B:F@8=*N;=hM}(B
        /* $B<!$N%U%!%$%k$r%5!<%A(B */
        result = FindNext(rptr);                            // $B<!$N%U%!%$%k$X(B
        if((result==0)&&(Record.attributes==ATTR_ARCHIVE)){ // $B%U%!%$%k$,8+$D$+$C$?>l9g(B
            fptr = FSfopen(Record.filename, FS_READ);       // $B%U%!%$%k$r%*!<%W%s(B
            Transfer();                                     // $B6J>pJsAw?.(B
        }
        else                                                // $B%U%!%$%k8+$D$+$i$:=*N;$N>l9g(B
        {
            result = FindFirst("*.*", ATTR_ARCHIVE, rptr);  //$B:G=i$N%U%!%$%k$rC5:w(B
            if(result == 0){                                // $B8+$D$+$C$?>l9g(B
                fptr = FSfopen(Record.filename, FS_READ);   // $B%U%!%$%k$N%*!<%W%s(B
                Transfer();                                 // $B6J%G!<%?Aw?.(B
            }
        }
    }
    IFS1bits.CNIF = 0;                                      // $B3d$j9~$_%U%i%0%/%j%"(B
}
/******************************************
*  UART$B<u?.3d$j9~$_=hM}4X?t(B
*  $B>o$K!V(BE$B!W<u?.$^$G<h$j9~$`(B
*******************************************/
void __attribute__((interrupt, no_auto_psv))  _U1RXInterrupt(void)
{
    unsigned char  data;
    while(U1STAbits.URXDA){                         // $B<u?.%P%C%U%!$K%G!<%?$"$k4V7+$jJV$9(B
        /* $B<u?.%(%i!<%A%'%C%/(B */
        IFS0bits.U1RXIF = 0;                        // $B3d$j9~$_%U%i%0%/%j%"(B
        if(U1STAbits.OERR || U1STAbits.FERR) {      // $B<u?.%(%i!<$"$j$+!)(B
            data = U1RXREG;;                        // $B%P%C%U%!<h$j=P$7(B
            U1STA &= 0xFFF0;                        // $B%(%i!<%U%i%0%/%j%"(B
            U1MODE = 0;                             // UART1$BDd;_(B
            U1MODE = 0x8808;                        // UART1$B:FM-8z2=(B
            Index = 0;                              // $B%P%C%U%!%$%s%G%C%/%9%j%;%C%H(B
        }
        else {                                      // $B@5>o<u?.$N>l9g(B
            data = U1RXREG;                         // $B%G!<%?<hF@(B
            if((Index < 5) && (data != 'E')){       // $B=*N;%^!<%/$+!)(B
                RcvBuf[Index++] = data;             // $B%G!<%?$r%P%C%U%!$KJ]B8(B
            }
            else{                                   // $B=*N;$N>l9g(B
                 /** $B<u?.%G!<%?=hM}(B **/
                if(RcvBuf[0] == 'S'){               // $B3+;O%^!<%/3NG'(B
                    switch(RcvBuf[1]){              // $B%3%^%s%I<oJL$GJ,4t(B
                        case 'U':                   // $B2;NL%"%C%W%3%^%s%I$N>l9g(B
                            if(Volume > 4)          // $B:G9b(B0(0dB)
                                Volume -= 4;        // $B%"%C%W(B
                            ChgFlag = 1;            // $BJQ99%U%i%0%;%C%H(B
                            break;
                        case 'L':                   // $B2;NL%@%&%s%3%^%s%I$N>l9g(B
                            if(Volume < 0xC0)       // $B:GDc$r(B0xC0$B$G@)8B!JL52;!K(B
                                Volume += 4;        // $B2;NL%@%&%s(B
                            ChgFlag = 1;            // $BJQ99%U%i%0%;%C%H(B
                            break;
                        case 'B':                   // $B%P%9%V!<%9%H(B
                            if(BASS<15)             // 15$B:GBg(B
                                BASS ++;            // BASS Boost$B%"%C%W(B
                            ChgFlag = 1;            // $BJQ99%U%i%0%*%s(B
                            break;
                        case 'C':                   // $B%U%i%C%H@_Dj(B                       
                            if(BASS > 0)            // $B:GDc(B0
                                BASS--;             // Bass$B%@%&%s(B
                            ChgFlag = 1;            // $BJQ99%U%i%0%;%C%H(B
                            break;
                        case 'H':                   // $B9b2;%V!<%9%H(B
                            if(TREB<7)              // 7$B$h$j>.$5$$>l9g(B
                                TREB++;             // $B9b2;%"%C%W(B
                            ChgFlag = 1;            // $BJQ99%U%i%0%*%s(B
                            break;
                        case 'I':                   // $B9b2;%@%&%s(B
                            if(TREB > 0)            // 0$B$h$jBg$-$$>l9g(B
                                TREB--;             // $B9b2;%@%&%s(B
                            ChgFlag = 1;            // $BJQ99%U%i%0%*%s(B
                            break;
                        case 'N':                   // $B6JAw$j%3%^%s%I$N>l9g(B
                            FSfclose(fptr);         // $B8=:_$N%U%!%$%k$r6/@)%/%m!<%:(B
                            PlayEnd();              // $B:F@8=*N;=hM}(B
                            /* $B<!$N%U%!%$%k$r%5!<%A(B */
                            result = FindNext(rptr);                            // $B<!$N%U%!%$%k$X(B
                            if((result==0)&&(Record.attributes==ATTR_ARCHIVE)){ // $B%U%!%$%k$,8+$D$+$C$?>l9g(B
                                fptr = FSfopen(Record.filename, FS_READ);       // $B%U%!%$%k$r%*!<%W%s(B
                                Transfer();                                     // $B6J>pJsAw?.(B
                            }
                            else                                                // $B%U%!%$%k8+$D$+$i$:=*N;$N>l9g(B
                            {
                                result = FindFirst("*.*", ATTR_ARCHIVE, rptr);  //$B:G=i$N%U%!%$%k$rC5:w(B
                                if(result == 0){                                // $B8+$D$+$C$?>l9g(B
                                    fptr = FSfopen(Record.filename, FS_READ);   // $B%U%!%$%k$N%*!<%W%s(B
                                    Transfer();                                 // $B6J%G!<%?Aw?.(B
                                }
                            }
                            break;
                        default :                   // $B$I$l$G$b$J$$$H$-(B
                            break;                  // $B2?$b$7$J$$(B
                    }
                    Index = 0;                      // $B%P%C%U%!%$%s%G%C%/%9%j%;%C%H(B
                }
            }
        }
    }
}
 /*****************************************
 * UART $BAw?.<B9T%5%V4X?t(B
 ******************************************/
void SendUART(unsigned char Data){
    while(!U1STAbits.TRMT);              // $BAw?.%l%G%#!<BT$A(B
    U1TXREG = Data;                      // $BAw?.<B9T(B
}
/*******************************************
 * Bluetooth$B$G%G!<%?$r0l3gAw?.$9$k4X?t(B
 ******************************************/
void SendBT(unsigned char * ptr, int size)
{
    int i;
    
    for(i= 0; i<Max_Size; i++)               // size$B%P%$%HAw?.(B
        SendUART(*ptr++);               // $BAw?.<B9T(B
}
/********************************************
 * Bletooth$B$GJ8;zNsAw?.(B
 *******************************************/
void SendStr(unsigned char *ptr)
{
    while(*ptr != 0)                    // $BG[Ns=*$o$j$^$G7+$jJV$7(B
        SendUART(*ptr++);
}
/******************************************
 * Bluetooth$B%3%^%s%IAw?.4X?t(B
 * $BCY1dA^F~8eLa$k(B
 *****************************************/
void SendCmd(const unsigned char *cmd)
{
    while(*cmd != 0)                    // $B=*C<$^$G7+$jJV$7Aw?.(B
        SendUART(*cmd++);               // $BAw?.<B9T(B
    delay_ms(1000);                     // $BJV?.%9%-%C%WMQCY1d(B

}

