/*****************************************************
*$B!!!!(BVS1011E$B!!@)8f%i%$%V%i%j(B
*
******************************************************/
#include "VS1011.h"
#include <xc.h>
/************************************
* SPI Read after Write$B!!4pK\4X?t(B
************************************/
BYTE WriteSPI(BYTE output){
    MP3_SPI_IF = 0;			// $B3d$j9~$_%U%i%0%/%j%"(B
    MP3_SSPBUF = output;		// SPI$B=PNO(B
    while(!MP3_SPI_IF);			// $BF~NOBT$A(B
    return MP3_SSPBUF;			// $BF~NO%G!<%?La$jCM(B
}
/************************************
*  VS1011$BMQ%3%^%s%I=PNO4X?t(B
************************************/
void Command(BYTE RegAdrs, BYTE UpData, BYTE LowData){
    MP3_XDCS_IO = 1;			// $B%G!<%?%b!<%I2r=|(B
    while(!MP3_DREQ_IO);		// $B%l%G%#!<BT$A(B
    MP3_XCS_IO = 0;			// $B%3%^%s%I%b!<%I@_Dj(B
    WriteSPI(0x02);			// $B=q$-9~$_F0:n;XDj(B
    WriteSPI(RegAdrs);			// $B%l%8%9%?%"%I%l%9=PNO(B
    WriteSPI(UpData);			// $B>e0L%P%$%H=PNO(B
    WriteSPI(LowData);			// $B2<0L%P%$%H=PNO(B
    MP3_XCS_IO = 1;			// $B%3%^%s%I%b!<%I2r=|(B
}
/************************************
*  VS1011$BMQ%3%^%s%I=PNO4X?t(B($B3NG'IU$-(B)
************************************/
void CmdCheck(BYTE RegAdrs, BYTE UpData, BYTE LowData){
    BYTE b1,b2;

    do{
        MP3_XDCS_IO = 1;		// $B%G!<%?%b!<%I2r=|(B
        while(!MP3_DREQ_IO);            // $B%l%G%#!<BT$A(B
        MP3_XCS_IO = 0;			// $B%3%^%s%I%b!<%I@_Dj(B
        WriteSPI(0x02);			// $B=q$-9~$_F0:n;XDj(B
        WriteSPI(RegAdrs);		// $B%l%8%9%?%"%I%l%9=PNO(B
        WriteSPI(UpData);		// $B>e0L%P%$%H=PNO(B
        WriteSPI(LowData);		// $B2<0L%P%$%H=PNO(B
        MP3_XCS_IO = 1;			// $B%3%^%s%I%b!<%I2r=|(B
        while(!MP3_DREQ_IO);            // $B%l%G%#!<BT$A(B
        MP3_XCS_IO = 0;			// $BFI$_9~$_3NG'(B
        WriteSPI(0x03);			// $BFI$_9~$_F0:n(B
        WriteSPI(RegAdrs);		// $B%l%8%9%?%"%I%l%9;XDj(B
        b1 = WriteSPI(0xFF);            // return UpData
        b2 = WriteSPI(0xFF);            // return LowData
        MP3_XCS_IO = 1;
    }while((b1 != UpData) || (b2 != LowData));
}
/************************************
*  VS1011$BMQ%G!<%?=PNO4X?t(B
************************************/
void SendData(BYTE Data){
    while(!MP3_DREQ_IO);                // $B%l%G%#!<BT$A(B
    WriteSPI(Data);
}

/***********************************************
*  $B2;NL%l%Y%k@_Dj4X?t(B
*   vRight = $B1&%A%c%M%kMQ2;NL(B
*   vLeft  = $B:8%A%c%M%kMQ2;NL(B
*$B!!!!(B   $B$$$9$l$b!!(B0x00=Max 0dB 0.5dB$B%9%F%C%W$G2<$,$k(B
************************************************/
void SetVolume(BYTE vRight, BYTE vLeft){
    Command(0x0B, vRight, vLeft);
}

/**********************************************
*  $BDc2;%V!<%9%H@_Dj@)8f4X?t(B
*    bass$B!'(B $BDc2;%2%$%s!!%l%s%8$O(B0dB$B$+$i(B15dB$B$NHO0O(B
*    gfreq: $BDc2;%V!<%9%H<~GH?t@_Dj!!(B10Hz$B%9%F%C%W!!(B0$B!)(B15$B$NHO0O(B
***********************************************/
void SetBassBoost(BYTE bass, BYTE gfreq)
{
    BYTE temp1 = 0;
    /* $B@_DjHO0O$N@)8B(B */
    if(bass > 15)
        bass = 15;
    if(gfreq > 15)
        gfreq = 15;
    /* 8$B%S%C%H$K9g@.(B */
    temp1 = gfreq;
    temp1 |= (bass << 4);
    Command(0x02, 0xFF, temp1);		// BASS
}
/**********************************************
*  $B2;<A@_Dj@)8f4X?t(B
*    bass$B!'(B $BDc2;%l%Y%k!!%l%s%8$O(B0dB$B$+$i(B15dB$B$NHO0O(B
*    gfreq: $BDc2;<~GH?t@_Dj!!(B10Hz$B%9%F%C%W!!(B0-15$B$NHO0O(B
*$B!!!!(Btreb$B!'(B $B9b2;%l%Y%k(B  $B%l%s%8$O(B0-7$B$^$G$,%"%C%W(B
*    tfreq$B!'9b2;<~GH?t@_Dj!!(B1kHz$B%9%F%C%W(B
***********************************************/
void SetBoost(BYTE bass, BYTE gfreq, BYTE treb, BYTE tfreq)
{
	BYTE temp1 = 0;
	BYTE temp2 = 0;
	/* $BDc2;@_DjHO0O$N@)8B(B */
	if(bass > 15)                   // 15$B$h$jBg$-$$>l9g(B
		bass = 15;              // 15$B$G@)8B(B
	if(gfreq > 15)                  // 15$B$h$jBg$-$$>l9g(B
		gfreq = 15;             // 15$B$G@)8B(B(150Hz)
	/* 8$B%S%C%H$K9g@.(B */
	temp1 = bass << 4;              // $BDc2;%P%$%H@8@.(B
        temp1 += gfreq;
        /* $B9b2;@_DjHO0O$N@)8B(B */
	if(treb > 7)                    // 7$B$h$jBg$-$$>l9g(B
		treb = 7;               // 7$B$G@)8B(B
	if(tfreq > 15)                  // 15$B$h$jBg$-$$>l9g(B
		tfreq = 15;             // 15$B$G@)8B(B(15kHz)
	/* 8$B%S%C%H$K9g@.(B */        
	temp2 = tfreq;                  // $B9b2;%P%$%H@8@.(B
	temp2 += (treb << 4);
        /* $B@_Dj@)8f(B  */
	Command(0x02, temp2, temp1);
}
/*********************************************
*	$B:F@8=*N;=hM}4X?t(B
*
*********************************************/
void PlayEnd(void){
    int i;

    /* $B:F@8%P%C%U%!%/%j%"$N$?$a(B2048$B%P%$%HAw?.!!(B*/
    MP3_XDCS_IO = 0;				// XDCS$B%*%s(B
    for(i=0; i<2048; i++)
            SendData(0);			// 0$B$N%G!<%?O"B3Aw?.(B
    MP3_XDCS_IO = 1;				// XDCS$B%*%U(B
    /*** $B%=%U%H%&%'%"%j%;%C%H$G40N;(B **/
    Command(0x00, 0x08, 0x24);			// SM_RESET$BAw?.(B
    while(!MP3_DREQ_IO);			// $B%3%^%s%I40N;BT$A(B
}
/********************************************
*  VS1011 $B=i4|2=4X?t(B
*    VS1011$BE>Aw%b!<%I!"(BSDI$B%F%9%H%b!<%I!!$K@_Dj(B
*    VS1011$B$H@5>o$KDL?.$G$-$J$$$H1J5WBT$A$H$J$k(B
*********************************************/
void VS1011_Init(void){
    unsigned int val;
    /***** VS1011$BMQ%]!<%H$N=i4|@_Dj(B   ***/
    MP3_XDCS_IO = 1;				// DCS$B$r(BHigh
    MP3_XCS_IO = 1;				// XCS$B$r(BHigh
    MP3_XRESET_IO = 0;                          // XRESET$B$r(BLow
    MP3_XRESET_TRIS = 0;			// $B=PNO(BTRIS$BM-8z2=(B
    MP3_DREQ_TRIS = 1;				// DREQ$BF~NO%b!<%I$K(B
    MP3_XDCS_TRIS = 0;				// XDCS$B=PNO(B
    MP3_XCS_TRIS = 0;				// XCS$B=PNO(B
    MP3_SDI_TRIS = 1;				// SDI2$BF~NO%b!<%I(B
    MP3_SDO_TRIS = 0;				// SDO2$B=PNO%b!<%I(B
    MP3_SCK_TRIS = 0;				// SCK2$B=PNO%b!<%I(B
    /***** SPI2$B$N=i4|@_Dj(B   ***/
    MP3_SPICON1 = 0x033E;			// 8$B%S%C%H%b!<%I(B,CKP = 0,CLK=Fosc/4 (4MHz)
                                                // End$B$G%5%s%W%k(B(SMP=1) $BN)>e$j%(%C%8$GAw?.(B(CKE=0)
    MP3_SPICON2 = 0;				// $B%U%l!<%`%b!<%I$J$7(B
    MP3_SPI_IF = 0;				// $B3d$j9~$_%U%i%0%/%j%"(B
    MP3_SPISTATbits.SPIEN = 1;                  // SPI2$B%$%M!<%V%k(B
    /* RESET$B2r=|!"(BVS1011$B%9%?!<%H(B  */
    delay_ms(10);				// 10msec delay
    MP3_XRESET_IO = 1;                          // RESET$B2r=|(B
    delay_ms(50);				// 50msec delay   
    /** $B%b!<%I@_Dj!!(B*/
    CmdCheck(0x00, 0x08, 0x20);                 // $B%b!<%I=i4|@_Dj!!?7%b!<%I!"(BSDI$B%F%9%H%b!<%I(B
    /* $B%/%m%C%/%@%V%i@_Dj!!(B*/
    val = 12288 / 2 + 0x8000;                   // $B@_DjCM$r5a$a$k!J%G!<%?%7!<%H$h$j!K(B
    CmdCheck(0x03, (BYTE)(val /256), (BYTE)val);
    delay_ms(50);
}

/********************************************
*  VS1011 $B@589GH%F%9%H%b!<%I@_Dj4X?t(B
*    MODE$B$r(BSPI$B%F%9%H%b!<%I$K@_Dj$7$F$*$/I,MW$,$"$k(B
*********************************************/
void VS1011_SineTest(void)
{
    /* $B%F%9%H%b!<%I%7!<%1%s%9=PNO(B */
    while(!MP3_DREQ_IO);
    MP3_XDCS_IO = 0;
    // Start Sine Test
    WriteSPI(0x53);
    WriteSPI(0xEF);
    WriteSPI(0x6E);
    WriteSPI(0x7D);		// 22.050kHz Out is 5kHz
    WriteSPI(0x00);
    WriteSPI(0x00);
    WriteSPI(0x00);
    WriteSPI(0x00);
    MP3_XDCS_IO = 1;
}
/****************************
* usec$BC10L%G%#%l%$4X?t(B
****************************/
void delay_us(int usec){
    usec = (int)(CLOCK*usec)/ 10;
    while(usec)	{
        asm("NOP");
        asm("NOP");
        asm("NOP");
        asm("NOP");
        asm("NOP");
        usec--;
    }
}
/***************************
* msec$BC10L%G%#%l%$4X?t(B
***************************/
void delay_ms(int msec){
    int i;
    for(i=0; i< msec; i++)
        delay_us(1000);
}


