/******************************************
*  I2C$BDL?.%i%$%V%i%j(B
******************************************/
#include <xc.h>
#include "i2c_lib3.h"

/*************************************
* I2C$B%P%9$r;H$C$F%G!<%?Aw?.(B
**************************************/
void SendI2C(unsigned Adrs, unsigned char Data)
{
    IdleI2C();
    SSPCON2bits.SEN = 1;   		// $B%9%?!<%H=PNO(B//
    while(SSPCON2bits.SEN);		// $B%9%?!<%H=*N;BT$A(B
    SendByte(Adrs);                     // $B%"%I%l%9!\Aw?.%b!<%IAw?.(B
    SendByte(Data);                     // $B%3%^%s%I%G!<%?Aw?.(B
    SSPCON2bits.PEN = 1;   		// $B%9%H%C%W=PNO(B
    while(SSPCON2bits.PEN);		// $B%9%H%C%W=*N;BT$A(B
}
/****************************************
* I2C$B%P%9$r;H$C$F%3%^%s%IAw?.(B
*****************************************/
void CmdI2C(unsigned Adrs, unsigned Reg, unsigned char Data)
{
    IdleI2C();
    SSPCON2bits.SEN = 1;   		// $B%9%?!<%H=PNO(B//
    while(SSPCON2bits.SEN);		// $B%9%?!<%H=*N;BT$A(B
    SendByte(Adrs);                     // $B%"%I%l%9!\Aw?.%b!<%IAw?.(B
    SendByte(Reg);                      // $B%l%8%9%?;XDjAw?.(B
    SendByte(Data);                     // $B%3%^%s%I%G!<%?Aw?.(B
    SSPCON2bits.PEN = 1;   		// $B%9%H%C%W=PNO(B
    while(SSPCON2bits.PEN);		// $B%9%H%C%W=*N;BT$A(B
}
/** $B%"%$%I%kBT$A%5%V4X?t!!(B***/
void IdleI2C(void){
    while(SSPCON2bits.SEN || SSPCON2bits.PEN || SSPCON2bits.RCEN
            || SSPCON2bits.ACKEN || SSPSTATbits.R_nW);
}
/****************************************
* $B!!(BI2C$B$G(B1$B%P%$%HAw?.(B
*****************************************/
void SendByte(unsigned char ch){
    SSPBUF = ch;			// $B%G!<%?%;%C%HAw?.3+;O(B
    while(SSPSTATbits.BF);		// $BAw?.=*N;BT$A(B
    
    while(SSPCON2bits.ACKSTAT);        // ACK$BJV?.BT$A(B
    IdleI2C();				// $B%"%$%I%kBT$A(B    
}
/*****************************************
* I2C$B%P%9$r;H$C$F(Bn$B%P%$%H<u?.(B
******************************************/
void GetDataI2C(unsigned char Adrs, unsigned char *Buffer, unsigned char Cnt)
{
    unsigned char i;

    IdleI2C();				// $B%"%$%I%kBT$A(B
    SSPCON2bits.SEN = 1;   		// $B%9%?!<%H=PNO(B
    while(SSPCON2bits.SEN);		// $B%9%?!<%H=*N;BT$A(B
    SendByte(Adrs+1);                   // $B%"%I%l%9!\<u?.%b!<%IAw?.(B    
    for(i=0; i<Cnt; i++)
        Buffer[i] = RcvByte(0);         // 1$B%P%$%H<u?.(B ACK$B1~Ez(B
    Buffer[i] = RcvByte(1);             // $B:G=*%P%$%H<u?.(B NACK$B1~Ez(B
    SSPCON2bits.PEN = 1;   		// $B%9%H%C%W=PNO(B
    while(SSPCON2bits.PEN);		// $B%9%H%C%W=*N;BT$A(B
}
/****************************************
* $B!!(BI2C$B$G(B1$B%P%$%H<u?.(B ACK/NACK $BJVAw(B
*****************************************/
unsigned char RcvByte(unsigned char Ans){
    unsigned char data;
    
    SSPCON2bits.ACKDT = Ans;		// ACK(0)/Nack(1)$B@_Dj(B
    SSPCON2bits.RCEN = 1;		// $B<u?.5v2D(B RCEN$B%;%C%H(B
    while(!SSPSTATbits.BF);            // $B<u?.BT$A(B BF$B%A%'%C%/(B
    SSPCON2bits.ACKEN = 1;		// ACK$BJVAw(B
    data = SSPBUF;			// $B<u?.%G!<%?<hF@(B
    SSPCON1bits.SSPOV = 0;		// $B%(%i!<%/%j%"(B
    IdleI2C();				// $B%"%$%I%kBT$A(B
    return(data);
}