﻿'Socketクラスの呼び出し
Imports System
Imports System.Text
Imports System.Net.Sockets

Public Class Form1
    '共通変数の定義
    Dim ContFlag As Integer
    Dim RcvBuf(63) As Byte
    '送信コマンドデータ定義
    Dim SWInput As Byte() = Encoding.ASCII.GetBytes("SBE")
    Dim LED1On As Byte() = Encoding.ASCII.GetBytes("SC11E")
    Dim LED1Off As Byte() = Encoding.ASCII.GetBytes("SC10E")
    Dim LED2On As Byte() = Encoding.ASCII.GetBytes("SC21E")
    Dim LED2Off As Byte() = Encoding.ASCII.GetBytes("SC20E")
    Dim Shut As Byte() = Encoding.ASCII.GetBytes("SNE")
    'TCPクライアントクラスとNetworkStreamクラスのインスタンス生成
    Dim TcpClientA As New TcpClient()
    Dim MyStream As NetworkStream

    Private Sub Form1_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        Timer1.Enabled = False
    End Sub

    Private Sub Button1_Click(sender As System.Object, e As System.EventArgs) Handles Button1.Click
        Try
            TcpClientA.Connect(TextBox1.Text, 2000)  'リモートホストとポート2000で接続
            MyStream = TcpClientA.GetStream()
            TextBox2.Text = "接続成功!"
            ContFlag = 0
            Timer1.Interval() = 200         '200msecタイマ起動
            Timer1.Enabled() = True         'タイマ１起動
        Catch ex As Exception
            TextBox2.Text = "接続失敗??"
        End Try
    End Sub

    Private Sub Button2_Click(sender As System.Object, e As System.EventArgs) Handles Button2.Click
        'End送信
        If TcpClientA.Connected = True Then
            MyStream.Write(Shut, 0, Shut.Length)
            MyStream.Close()            'ストリームクローズ
            TcpClientA.Close()          'TCPのクローズ
        End If
        Timer1.Enabled = False          'タイマ１停止
        Close()
    End Sub

    Private Sub Button3_Click(sender As System.Object, e As System.EventArgs) Handles Button3.Click
        '現在状態によりオンオフを反転制御
        If Button3.Text = "Off" Then
            ContFlag = 1
        Else
            ContFlag = 2
        End If
    End Sub

    Private Sub Button4_Click(sender As System.Object, e As System.EventArgs) Handles Button4.Click
        '現在状態によりオンオフを反転制御
        If Button4.Text = "On" Then
            ContFlag = 3
        Else
            ContFlag = 4
        End If
    End Sub

    Private Sub Timer1_Tick(sender As System.Object, e As System.EventArgs) Handles Timer1.Tick
        Dim data As Integer

        'TCP受信
        If TcpClientA.Available > 0 Then                    '受信データありの場合
            MyStream.Read(RcvBuf, 0, RcvBuf.Length)         '受信データ取り出し

            '******** 受信データ処理 ******
            If RcvBuf(0) = &H4D Then                        '最初がMの場合のみ実行
                '状態応答の処理
                If RcvBuf(1) = &H42 Then                    'Bの場合
                    'オンオフ状態により色とテキストを変更
                    If RcvBuf(2) = &H31 Then
                        Button3.BackColor = Color.Red
                        Button3.Text = "On"
                    Else
                        Button3.BackColor = Color.Green
                        Button3.Text = "Off"
                    End If
                    If RcvBuf(3) = &H31 Then
                        Button4.BackColor = Color.Red
                        Button4.Text = "On"
                    Else
                        Button4.BackColor = Color.Green
                        Button4.Text = "Off"
                    End If
                    '状態表示
                    If RcvBuf(4) = &H30 Then
                        TextBox3.BackColor = Color.Red
                        TextBox3.Text = "On"
                    Else
                        TextBox3.BackColor = Color.Green
                        TextBox3.Text = "Off"
                    End If
                    If RcvBuf(5) = &H30 Then
                        TextBox4.BackColor = Color.Red
                        TextBox4.Text = "On"
                    Else
                        TextBox4.BackColor = Color.Green
                        TextBox4.Text = "Off"
                    End If
                    '計測データ変換と表示
                    data = (RcvBuf(6) - &H40) * 32 + RcvBuf(7) - &H40
                    TextBox5.Text = data.ToString("F0")
                    data = (RcvBuf(8) - &H40) * 32 + RcvBuf(9) - &H40
                    TextBox6.Text = data.ToString("F0")
                    'どれでもない場合
                Else
                    TextBox3.Text = "受信合致なし？？？"
                End If
            End If

        Else
            '******受信なしの場合制御があれば実行する*******
            If ContFlag = 1 Then
                MyStream.Write(LED1On, 0, LED1On.Length)
            ElseIf ContFlag = 2 Then
                MyStream.Write(LED1Off, 0, LED1Off.Length)
            ElseIf ContFlag = 3 Then
                MyStream.Write(LED2Off, 0, LED2Off.Length)
            ElseIf ContFlag = 4 Then
                MyStream.Write(LED2On, 0, LED2On.Length)
            Else
                '******* 制御がなければ状態要求 *******
                MyStream.Write(SWInput, 0, SWInput.Length)
            End If
            ContFlag = 0
        End If
    End Sub
End Class
