﻿'クラスの呼び出し
Imports System.Text
Imports System.Net
Imports System.Net.Sockets

Public Class Form1
    '共通変数の定義
    Dim RcvBuf As Byte()                '受信バッファ
    Dim ContFlag As Byte                '制御要求フラグ    
    '送信コマンドデータ定義
    Dim SWInput As Byte() = Encoding.ASCII.GetBytes("SBE")
    Dim LED1On As Byte() = Encoding.ASCII.GetBytes("SC11E")
    Dim LED1Off As Byte() = Encoding.ASCII.GetBytes("SC10E")
    Dim LED2On As Byte() = Encoding.ASCII.GetBytes("SC21E")
    Dim LED2Off As Byte() = Encoding.ASCII.GetBytes("SC20E")
    Dim Shut As Byte() = Encoding.ASCII.GetBytes("SNE")

    'Socketクラス インスタンス生成
    Dim udpClientA As New UdpClient(3000)           'ローカルポート3000でインスタンス生成
    'リモートホスト定義（任意アドレス）
    Dim RemoteIPEndPoint As IPEndPoint = Nothing    '相手は特に決めない

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Timer1.Enabled = False                      'タイマは停止させる
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        'リモートの接続（IPアドレスで指定）
        Try
            udpClientA.Connect("192.168.1.22", 2000)    '通信相手を特定する
            TextBox1.Text = "接続成功!"
            Timer1.Interval() = 200                      '200msecタイマ起動
            Timer1.Enabled() = True                     'タイマ１起動
        Catch ex As Exception
            TextBox1.Text = "接続失敗?"
        End Try
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        udpClientA.Send(Shut, Shut.Length)
        Timer1.Enabled = False              'タイマ１停止
        udpClientA.Close()                  'UDPのクローズ
        Close()
    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        '現在状態によりオンオフを反転制御
        If Button3.Text = "On" Then
            ContFlag = 1                '制御要求フラグセット
        Else
            ContFlag = 2
        End If
    End Sub

    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click
        '現在状態によりオンオフを反転制御
        If Button4.Text = "On" Then
            ContFlag = 3                '制御要求フラグセット
        Else
            ContFlag = 4
        End If
    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        Dim Data As Integer

        '********受信データがある場合受信実行************
        If udpClientA.Available > 0 Then
            '受信データ取り出し実行
            RcvBuf = udpClientA.Receive(RemoteIPEndPoint)
            '受信データの処理
            If RcvBuf(0) = &H4D Then                          'Mの場合
                ' ***** 状態の応答の場合 *****
                If RcvBuf(1) = &H42 Then                      'Bの場合
                    'オンオフ状態により色とテキストを変更
                    If RcvBuf(2) = &H31 Then
                        Button3.BackColor = Color.Red
                        Button3.Text = "On"
                    Else
                        Button3.BackColor = Color.Green
                        Button3.Text = "Off"
                    End If
                    If RcvBuf(3) = &H31 Then
                        Button4.BackColor = Color.Red
                        Button4.Text = "On"
                    Else
                        Button4.BackColor = Color.Green
                        Button4.Text = "Off"
                    End If
                    'オンオフ表示制御
                    If RcvBuf(4) = &H30 Then
                        TextBox3.BackColor = Color.Red
                        TextBox3.Text = "On"
                    Else
                        TextBox3.BackColor = Color.Green
                        TextBox3.Text = "Off"
                    End If
                    If RcvBuf(5) = &H30 Then
                        TextBox4.BackColor = Color.Red
                        TextBox4.Text = "On"
                    Else
                        TextBox4.BackColor = Color.Green
                        TextBox4.Text = "Off"
                    End If
                    '汎用計測表示
                    Data = (RcvBuf(6) - &H40) * 32 + RcvBuf(7) - &H40
                    TextBox5.Text = Data.ToString("F0")
                    Data = (RcvBuf(8) - &H40) * 32 + RcvBuf(9) - &H40
                    TextBox6.Text = Data.ToString("F0")
                End If
            End If

        Else
            '**********受信データがない場合、制御送信実行**********
            If ContFlag = 1 Then
                udpClientA.Send(LED1Off, LED1Off.Length)
            ElseIf ContFlag = 2 Then
                udpClientA.Send(LED1On, LED1On.Length)
            ElseIf ContFlag = 3 Then
                udpClientA.Send(LED2Off, LED2Off.Length)
            ElseIf ContFlag = 4 Then
                udpClientA.Send(LED2On, LED2On.Length)
            Else
                '*********制御が無い場合状態要求 ********
                udpClientA.Send(SWInput, SWInput.Length)
            End If
            ContFlag = 0
        End If

    End Sub
End Class
